<?php

declare(strict_types=1);

namespace Drupal\gradient;

use Drupal\Component\Serialization\Json;

/**
 * The colors man the colors!
 */
class Gradient {

  public static function getGradientBackgroundRule(string $gradient_input, string $unique_class): string {
    $saved_values = self::getValuesFromInput($gradient_input);

    $gradient_string = self::getLinearGradientString($saved_values);
    return sprintf(".%s {\n  background: linear-gradient(%sdeg, %s);\n}\n", $unique_class, $saved_values['angle'], $gradient_string);
  }

  public static function getLinearGradientString(array $saved_values): string {
    $gradient_string = '';
    foreach ($saved_values['stops'] as $stop) {
      if (!empty($gradient_string)) {
        $gradient_string .= ', ';
      }
      $gradient_string .= "{$stop['color']} {$stop['position']}%";
    }
    return $gradient_string;
  }

  public static function getValuesFromInput(string $gradient_input): array {
    return Json::decode($gradient_input);
  }

}
